-- Copyright 2016 Stanford University
--
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
--
--     http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.

-- Inspired by https://github.com/ParRes/Kernels/tree/master/LEGION/Stencil

import "regent"
local c = regentlib.c

function Array(ElemType)
  local struct ArrayType{
    data: &ElemType;
    N: int

			}
  -- Every struct has a namespace for associated methods.
  -- Similar to, but a bit more restrictive than, methods in object-oriented languages.
  terra ArrayType:get(i: int): ElemType
    return self.data[i]
  end

  terra ArrayType:init(size: int)
      self.data = [&ElemType](c.malloc(size * sizeof(ElemType)))
      self.N = size
  end
  
  return ArrayType
end

FloatArray = Array(float)

terra mysum(size:int64): float
  var r: FloatArray

  -- an example of calling a method on a struct
  r:init(size)
  for i = 0,r.N do
    r.data[i] = 1.0
  end
  var s = 0.0
  for i = 0,r.N do
    s = s + r.data[i]
  end
  return s
end

c.printf("%f\n",mysum(10))




